"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var PropTypes = require("prop-types");
var not_equal_1 = require("bicycle/utils/not-equal");
var query_1 = require("bicycle/typed-helpers/query");
var client_shape_1 = require("../client-shape");
var component_class_1 = require("../component-class");
var hoistStatics = require('hoist-non-react-statics');
var EMPTY_OBJECT = {};
function queryCache(client, query) {
    if (query instanceof query_1.BaseRootQuery) {
        return client.queryCache(query);
    }
    else {
        return client.queryCache(query);
    }
}
function subscribe(client, query, onUpdate) {
    if (query instanceof query_1.BaseRootQuery) {
        return client.subscribe(query, onUpdate);
    }
    else {
        return client.subscribe(query, onUpdate);
    }
}
function connect(WrappedComponent, getQuery, getEventHandlers, options) {
    if (options === void 0) { options = EMPTY_OBJECT; }
    var Connect = /** @class */ (function (_super) {
        __extends(Connect, _super);
        function Connect(props, context) {
            var _this = _super.call(this, props, context) || this;
            _this._onUpdate = function (result, loaded, errors, errorDetails) {
                _this.setState({ result: result, loaded: loaded, errors: errors, errorDetails: errorDetails });
            };
            _this._isLoaded = function (value, path) {
                if (typeof path === 'undefined') {
                    _a = [_this.state.result, value], value = _a[0], path = _a[1];
                }
                for (var _i = 0, _b = path.split('.'); _i < _b.length; _i++) {
                    var key = _b[_i];
                    if (value === undefined) {
                        return false;
                    }
                    else {
                        value = value[key];
                    }
                }
                return value !== undefined;
                var _a;
            };
            _this._client = context.bicycleClient;
            _this._renderLoading = options.renderLoading || context.bicycleRenderLoading || true;
            _this._renderErrors = options.renderErrors || context.bicycleRenderErrors || true;
            if (!_this._client) {
                throw new Error("Could not find \"client\" in either the context or " +
                    ("props of \"" + Connect.displayName + "\". ") +
                    "Either wrap the root component in a <Provider>, " +
                    ("or explicitly pass \"client\" as a prop to \"" + Connect.displayName + "\"."));
            }
            _this._query = (getQuery ? getQuery(props) : undefined) || undefined;
            var _a = _this._query ? queryCache(_this._client, _this._query) : { result: undefined, loaded: true, errors: [], errorDetails: [] }, result = _a.result, loaded = _a.loaded, errors = _a.errors, errorDetails = _a.errorDetails;
            _this.state = { result: result, loaded: loaded, errors: errors, errorDetails: errorDetails };
            return _this;
        }
        Connect.prototype.componentDidMount = function () {
            if (this._query) {
                this._subscription = subscribe(this._client, this._query, this._onUpdate);
            }
        };
        Connect.prototype.componentWillReceiveProps = function (nextProps) {
            var newQuery = (getQuery ? getQuery(nextProps) : undefined) || undefined;
            if (!newQuery) {
                if (this._subscription) {
                    this._subscription.unsubscribe();
                }
            }
            else if (!this._query ||
                not_equal_1.default(this._query instanceof query_1.BaseRootQuery ? this._query._query : this._query, newQuery instanceof query_1.BaseRootQuery ? newQuery._query : newQuery)) {
                if (this._subscription) {
                    this._subscription.unsubscribe();
                }
                this._query = newQuery;
                if (this._query) {
                    this._subscription = subscribe(this._client, this._query, this._onUpdate);
                }
            }
        };
        Connect.prototype.componentWillUnmount = function () {
            if (this._subscription) {
                this._subscription.unsubscribe();
            }
        };
        Connect.prototype.render = function () {
            var ComponentToRender = WrappedComponent;
            if (typeof this._renderErrors !== 'boolean' && this.state.errors.length) {
                ComponentToRender = this._renderErrors;
            }
            else if (typeof this._renderLoading !== 'boolean' && !this.state.loaded) {
                ComponentToRender = this._renderLoading;
            }
            var eventHandlers = getEventHandlers ? getEventHandlers(this._client, this.props) : EMPTY_OBJECT;
            var previousElement = this._previousElement;
            return this._previousElement = React.createElement(ComponentToRender, __assign({}, this.props, (this.state.result || {}), eventHandlers, { result: this.state.result, loaded: this.state.loaded, errors: this.state.errors, errorDetails: this.state.errorDetails, isLoaded: this._isLoaded, WrappedComponent: WrappedComponent,
                previousElement: previousElement }));
        };
        Connect.displayName = "Connect(" + component_class_1.getDisplayName(WrappedComponent) + ")";
        Connect.WrappedComponent = WrappedComponent;
        Connect.contextTypes = {
            bicycleClient: client_shape_1.default,
            bicycleRenderLoading: PropTypes.oneOfType([
                PropTypes.any,
                PropTypes.bool,
            ]),
            bicycleRenderErrors: PropTypes.oneOfType([
                PropTypes.any,
                PropTypes.bool,
            ]),
        };
        return Connect;
    }(React.Component));
    return hoistStatics(Connect, WrappedComponent);
}
exports.default = connect;
//# sourceMappingURL=connect-hoc.js.map