/// <reference types="react" />
import * as React from 'react';
import * as PropTypes from 'prop-types';
import BicycleClient from 'bicycle/client';
import ErrorResult from 'bicycle/types/ErrorResult';
export interface RenderProps {
    result: any;
    loaded: boolean;
    errors: ReadonlyArray<string>;
    errorDetails: ReadonlyArray<ErrorResult>;
    isLoaded(path: string): boolean;
    isLoaded(value: any, path: string): boolean;
    WrappedComponent: any;
    previousElement: React.ReactNode;
}
export declare type Component<Props> = React.ComponentClass<Props> | React.StatelessComponent<Props>;
export interface Props {
    client: BicycleClient<any>;
    disableErrorReporter?: boolean;
    renderLoading?: Component<RenderProps>;
    renderErrors?: Component<RenderProps>;
}
export default class Provider extends React.Component<Props> {
    client: BicycleClient<any>;
    renderLoading?: Component<RenderProps>;
    renderErrors?: Component<RenderProps>;
    static propTypes: {
        client: PropTypes.Validator<any>;
        disableErrorReporter: PropTypes.Requireable<any>;
        renderLoading: PropTypes.Requireable<any>;
        renderErrors: PropTypes.Requireable<any>;
        children: PropTypes.Validator<any>;
    };
    static defaultProps: {
        renderLoading: (props: RenderProps) => React.DetailedReactHTMLElement<{}, HTMLElement>;
        renderErrors: (props: RenderProps) => React.DetailedReactHTMLElement<{}, HTMLElement>;
    };
    static childContextTypes: {
        bicycleClient: PropTypes.Validator<any>;
        bicycleRenderLoading: PropTypes.Validator<any>;
        bicycleRenderErrors: PropTypes.Validator<any>;
    };
    getChildContext(): {
        bicycleClient: BicycleClient<any>;
        bicycleRenderLoading: React.ComponentClass<RenderProps> | React.StatelessComponent<RenderProps> | undefined;
        bicycleRenderErrors: React.ComponentClass<RenderProps> | React.StatelessComponent<RenderProps> | undefined;
    };
    constructor(props: Props, context: any);
    componentWillReceiveProps(nextProps: Props): void;
    render(): React.ReactElement<any>;
}
